var _babelRuntimeHelpersExtends = $parcel$interopDefault(require("@babel/runtime/helpers/extends"));

var {
  NumberFormatter
} = require("@internationalized/number");

var {
  MessageDictionary,
  MessageFormatter
} = require("@internationalized/message");

var {
  useIsSSR
} = require("@react-aria/ssr");

var _react2 = require("react");

var _react = $parcel$interopDefault(_react2);

var {
  useEffect,
  useState,
  useContext,
  useCallback,
  useMemo
} = _react2;

function $parcel$interopDefault(a) {
  return a && a.__esModule ? a.default : a;
}

/*
 * Copyright 2020 Adobe. All rights reserved.
 * This file is licensed to you under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. You may obtain a copy
 * of the License at http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS
 * OF ANY KIND, either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
// https://en.wikipedia.org/wiki/Right-to-left
const $dbb62b32f79d03a795a46f9fbec514c$var$RTL_SCRIPTS = new Set(['Arab', 'Syrc', 'Samr', 'Mand', 'Thaa', 'Mend', 'Nkoo', 'Adlm', 'Rohg', 'Hebr']);
const $dbb62b32f79d03a795a46f9fbec514c$var$RTL_LANGS = new Set(['ae', 'ar', 'arc', 'bcc', 'bqi', 'ckb', 'dv', 'fa', 'glk', 'he', 'ku', 'mzn', 'nqo', 'pnb', 'ps', 'sd', 'ug', 'ur', 'yi']);
/**
 * Determines if a locale is read right to left using [Intl.Locale]{@link https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Intl/Locale}.
 */

function $dbb62b32f79d03a795a46f9fbec514c$export$isRTL(locale) {
  // If the Intl.Locale API is available, use it to get the script for the locale.
  // This is more accurate than guessing by language, since languages can be written in multiple scripts.
  // @ts-ignore
  if (Intl.Locale) {
    // @ts-ignore
    let script = new Intl.Locale(locale).maximize().script;
    return $dbb62b32f79d03a795a46f9fbec514c$var$RTL_SCRIPTS.has(script);
  } // If not, just guess by the language (first part of the locale)


  let lang = locale.split('-')[0];
  return $dbb62b32f79d03a795a46f9fbec514c$var$RTL_LANGS.has(lang);
}

/**
 * Gets the locale setting of the browser.
 */
function $c53c7d716f930bd5da78e9efb99e3e$export$getDefaultLocale() {
  // @ts-ignore
  let locale = typeof navigator !== 'undefined' && (navigator.language || navigator.userLanguage) || 'en-US';
  return {
    locale,
    direction: $dbb62b32f79d03a795a46f9fbec514c$export$isRTL(locale) ? 'rtl' : 'ltr'
  };
}

let $c53c7d716f930bd5da78e9efb99e3e$var$currentLocale = $c53c7d716f930bd5da78e9efb99e3e$export$getDefaultLocale();
let $c53c7d716f930bd5da78e9efb99e3e$var$listeners = new Set();

function $c53c7d716f930bd5da78e9efb99e3e$var$updateLocale() {
  $c53c7d716f930bd5da78e9efb99e3e$var$currentLocale = $c53c7d716f930bd5da78e9efb99e3e$export$getDefaultLocale();

  for (let listener of $c53c7d716f930bd5da78e9efb99e3e$var$listeners) {
    listener($c53c7d716f930bd5da78e9efb99e3e$var$currentLocale);
  }
}
/**
 * Returns the current browser/system language, and updates when it changes.
 */


function $c53c7d716f930bd5da78e9efb99e3e$export$useDefaultLocale() {
  let isSSR = useIsSSR();
  let [defaultLocale, setDefaultLocale] = useState($c53c7d716f930bd5da78e9efb99e3e$var$currentLocale);
  useEffect(() => {
    if ($c53c7d716f930bd5da78e9efb99e3e$var$listeners.size === 0) {
      window.addEventListener('languagechange', $c53c7d716f930bd5da78e9efb99e3e$var$updateLocale);
    }

    $c53c7d716f930bd5da78e9efb99e3e$var$listeners.add(setDefaultLocale);
    return () => {
      $c53c7d716f930bd5da78e9efb99e3e$var$listeners.delete(setDefaultLocale);

      if ($c53c7d716f930bd5da78e9efb99e3e$var$listeners.size === 0) {
        window.removeEventListener('languagechange', $c53c7d716f930bd5da78e9efb99e3e$var$updateLocale);
      }
    };
  }, []); // We cannot determine the browser's language on the server, so default to
  // en-US. This will be updated after hydration on the client to the correct value.

  if (isSSR) {
    return {
      locale: 'en-US',
      direction: 'ltr'
    };
  }

  return defaultLocale;
}

const $aa95c2b730b505b265f124d9aec67193$var$I18nContext = /*#__PURE__*/_react.createContext(null);

function I18nProvider(props) {
  let {
    locale,
    children
  } = props;
  let defaultLocale = $c53c7d716f930bd5da78e9efb99e3e$export$useDefaultLocale();
  let value = locale ? {
    locale,
    direction: $dbb62b32f79d03a795a46f9fbec514c$export$isRTL(locale) ? 'rtl' : 'ltr'
  } : defaultLocale;
  return /*#__PURE__*/_react.createElement($aa95c2b730b505b265f124d9aec67193$var$I18nContext.Provider, {
    value: value
  }, children);
}
/**
 * Returns the current locale and layout direction.
 */


exports.I18nProvider = I18nProvider;

function useLocale() {
  let defaultLocale = $c53c7d716f930bd5da78e9efb99e3e$export$useDefaultLocale();
  let context = useContext($aa95c2b730b505b265f124d9aec67193$var$I18nContext);
  return context || defaultLocale;
}

exports.useLocale = useLocale;
const $a5aefbc9b72193c190dce301e0eb39$var$cache = new WeakMap();

function $a5aefbc9b72193c190dce301e0eb39$var$getCachedDictionary(strings) {
  let dictionary = $a5aefbc9b72193c190dce301e0eb39$var$cache.get(strings);

  if (!dictionary) {
    dictionary = new MessageDictionary(strings);
    $a5aefbc9b72193c190dce301e0eb39$var$cache.set(strings, dictionary);
  }

  return dictionary;
}
/**
 * Handles formatting ICU Message strings to create localized strings for the current locale.
 * Automatically updates when the locale changes, and handles caching of messages for performance.
 * @param strings - A mapping of languages to strings by key.
 */


function useMessageFormatter(strings) {
  let {
    locale
  } = useLocale();
  let dictionary = useMemo(() => $a5aefbc9b72193c190dce301e0eb39$var$getCachedDictionary(strings), [strings]);
  let formatter = useMemo(() => new MessageFormatter(locale, dictionary), [locale, dictionary]);
  return useCallback((key, variables) => formatter.format(key, variables), [formatter]);
}

exports.useMessageFormatter = useMessageFormatter;
let $bdeee39f835a1e28966186127db96579$var$formatterCache = new Map();
/**
 * Provides localized date formatting for the current locale. Automatically updates when the locale changes,
 * and handles caching of the date formatter for performance.
 * @param options - Formatting options.
 */

function useDateFormatter(options) {
  let {
    locale
  } = useLocale();
  let cacheKey = locale + (options ? Object.entries(options).sort((a, b) => a[0] < b[0] ? -1 : 1).join() : '');

  if ($bdeee39f835a1e28966186127db96579$var$formatterCache.has(cacheKey)) {
    return $bdeee39f835a1e28966186127db96579$var$formatterCache.get(cacheKey);
  }

  let formatter = new Intl.DateTimeFormat(locale, options);
  $bdeee39f835a1e28966186127db96579$var$formatterCache.set(cacheKey, formatter);
  return formatter;
}

exports.useDateFormatter = useDateFormatter;

/**
 * Provides localized number formatting for the current locale. Automatically updates when the locale changes,
 * and handles caching of the number formatter for performance.
 * @param options - Formatting options.
 */
function useNumberFormatter(options) {
  if (options === void 0) {
    options = {};
  }

  let {
    locale
  } = useLocale();
  return useMemo(() => new NumberFormatter(locale, options), [locale, options]);
}

exports.useNumberFormatter = useNumberFormatter;
let $f2d7166fa8b4811bca7b68ebd673b$var$cache = new Map();
/**
 * Provides localized string collation for the current locale. Automatically updates when the locale changes,
 * and handles caching of the collator for performance.
 * @param options - Collator options.
 */

function useCollator(options) {
  let {
    locale
  } = useLocale();
  let cacheKey = locale + (options ? Object.entries(options).sort((a, b) => a[0] < b[0] ? -1 : 1).join() : '');

  if ($f2d7166fa8b4811bca7b68ebd673b$var$cache.has(cacheKey)) {
    return $f2d7166fa8b4811bca7b68ebd673b$var$cache.get(cacheKey);
  }

  let formatter = new Intl.Collator(locale, options);
  $f2d7166fa8b4811bca7b68ebd673b$var$cache.set(cacheKey, formatter);
  return formatter;
}

exports.useCollator = useCollator;

/**
 * Provides localized string search functionality that is useful for filtering or matching items
 * in a list. Options can be provided to adjust the sensitivity to case, diacritics, and other parameters.
 */
function useFilter(options) {
  let collator = useCollator(_babelRuntimeHelpersExtends({
    usage: 'search'
  }, options)); // TODO(later): these methods don't currently support the ignorePunctuation option.

  return {
    startsWith(string, substring) {
      if (substring.length === 0) {
        return true;
      } // Normalize both strings so we can slice safely
      // TODO: take into account the ignorePunctuation option as well...


      string = string.normalize('NFC');
      substring = substring.normalize('NFC');
      return collator.compare(string.slice(0, substring.length), substring) === 0;
    },

    endsWith(string, substring) {
      if (substring.length === 0) {
        return true;
      }

      string = string.normalize('NFC');
      substring = substring.normalize('NFC');
      return collator.compare(string.slice(-substring.length), substring) === 0;
    },

    contains(string, substring) {
      if (substring.length === 0) {
        return true;
      }

      string = string.normalize('NFC');
      substring = substring.normalize('NFC');
      let scan = 0;
      let sliceLen = substring.length;

      for (; scan + sliceLen <= string.length; scan++) {
        let slice = string.slice(scan, scan + sliceLen);

        if (collator.compare(substring, slice) === 0) {
          return true;
        }
      }

      return false;
    }

  };
}

exports.useFilter = useFilter;
//# sourceMappingURL=main.js.map
